/*
	Filter for Weasel
        -----------------

	Test mail with DrWeb antivirus.
	Files:
		filter.cmd - this script
		virus.msg  - attention letter
		send.cmd   - ftp://ftp.os2.snc.ru/pub/weasel/send.zip

						Vasilkin Andrey, 2005 y.
*/

/****************************************************************/
/*                         Settings                             */
/****************************************************************/

LogFile = 'D:\logs\MailVir.log'     /* logfile of filter-drweb */
AntivirPath = 'H:\'                 /* path to DrWeb           */
RunDrWebCmd = "'DRWEB2CL.EXE /AR /NR /TB- /GO /HA /ML /NI /RP'TempFName' /NI /NM /UP 'InFile"

/****************************************************************/
/*                       MAIN PROGRAM                           */
/****************************************************************/

PARSE ARG InFile AddrFile

if right(AddrFile,4)='.###' then /* workaround for different versions */
do
  temp = InFile
  InFile = AddrFile
  AddrFile = temp
end

/* don't test letters from local host (for ex. virus attentions) */
if AddrFile\='' then
do
  SAddr = linein(AddrFile)
  call stream AddrFile, 'C', 'CLOSE'
  parse var SAddr '['SAddr']'
  if SAddr='127.0.0.1' then exit 0
end

/* ---------------------- Initialization ---------------------- */

CALL RxFuncAdd SysLoadFuncs, rexxutil, sysloadfuncs
CALL SysLoadFuncs

Globals = 'InFile ForwardPath ReturnPath'

/* ----------------------- Test with DrWeb -------------------- */

FilterRC = 0
if SAddr\=HostAddr then
do
  PARSE SOURCE rubbish rubbish SrcPath
  j = LASTPOS('\', SrcPath)
  if j > 0 then SrcPath = LEFT(SrcPath, j)
  TempFName = SysTempFileName(SrcPath'?????.tmp')

  /* ------------ Run antivirus ----------- */
  CurDir = directory()
  if directory(AntivirPath)='' then
  do
    say 'DRWEB-Filter: Invalid directory ('AntivirPath')'
    exit 0
  end
  interpret(RunDrWebCmd)
  DrWebRC = rc
  rc = directory(CurDir)

  if DrWebRC\=0 then
  do
    /* -------------- Infected ! ------------ */
    call CheckHeader

    if (ReturnPath\='') & (ForwardPath\=ReturnPath) then
    do
      parse upper var ReturnPath User'@'Domain
      if (Domain\='') & (User\='') & (User\='POSTMASTER') & (User\='MAILER-DAEMON') & (User\='NOREPLY') then
      do
        /* --- Read name of virus from logfile --- */
        VirusName = ''
        do while ((lines(TempFName)\=0) & (VirusName=''))
          parse value linein(TempFName) with FName' infected with 'VirusName
        end
        call stream TempFName, 'C', 'CLOSE'
        call SysFileDelete TempFName

        /* ------------ Append logfile ----------- */
        line = date('E')' 'time()' rc='DrWebRC' FROM: 'ReturnPath' ['SAddr']'
        line = line' INFECTED: 'VirusName
        line = line' TO: 'ForwardPath
        call lineout LogFile, line
        call stream LogFile, 'C', 'CLOSE'

        /* --------- Send virus attention -------- */
        MessageLetter = SrcPath||'virus.msg'
        if stream(MessageLetter,'c','query exists')='' then
          say 'DRWEB-Filter: File 'MessageLetter' not found'
        else do
          /* ------------ Create letter ------------ */
          do while lines(MessageLetter)\=0
            line = linein(MessageLetter)
            parse value line with s1'\%'key'%'s2
            select 
              when key='VIRUS' then key=VirusName
              when key='TO' then key=ForwardPath
              otherwise key=''
            end
            if key\='' then line = s1 || key || s2
            call lineout TempFName,line
          end
          call stream TempFName, 'C', 'CLOSE'
          call stream MessageLetter, 'C', 'CLOSE'

          /* ------------- Send letter ------------- */
          'call 'SrcPath'send.cmd -t 'ReturnPath' 'TempFName
        end
      end
    end
    FilterRC = 2
  end
  call SysFileDelete TempFName
end

EXIT FilterRC

/****************************************************************/


CheckHeader: PROCEDURE EXPOSE (Globals)
  InHeader = 1
  FirstLine = 1
  ForwardPath = ''
  ReturnPath = ''
  CurField = ''

  do while InHeader
    line = LineIn(InFile)
    if (line = "") & \FirstLine then InHeader = 0
    else if (LEFT(line,1) = ' ' | LEFT(line,1) = x2c('09')) then
      do
        if CurField = 'TO' then call AddForwardPath line
        else if CurField = 'FROM' then call AddReturnPath line 
      end
    else if (POS(':', line) = 0) & \FirstLine then InHeader = 0
    else
      do
        CurField = ''
        PARSE VALUE line WITH keyword ':' remainder
        keyword = TRANSLATE(keyword)
        if (keyword="FROM") | (keyword="RETURN-PATH") then
        do
          CurField = 'FROM'
          call AddReturnPath remainder
        end
        else if (keyword = "TO") | (keyword = "CC") | (keyword = "BCC") then
        do
          CurField = 'TO'
          call AddForwardPath remainder
        end
      end
    FirstLine = 0
  end
  call stream InFile, 'C', 'CLOSE'
return

AddForwardPath: PROCEDURE EXPOSE ForwardPath
  line = arg(1)
  do forever
    P = pos(',',line)
    if P=0 then item = line; else item = left(line,P-1)
    if item\='' & pos('@',item)\=0 then
    do
      item = CleanupAddress(strip(strip(item,'L',x2c('09'))))
      if ForwardPath='' then ForwardPath = item
      else ForwardPath = ForwardPath' 'item
    end
    if P=0 then leave
    line = substr(line,P+1)
  end
return

AddReturnPath: PROCEDURE EXPOSE ReturnPath
  line = arg(1)
  if ReturnPath\='' | pos('@',line)=0 then return
  ReturnPath = CleanupAddress(line)
return

CleanupAddress: PROCEDURE
    line = STRIP(arg(1))
    if LEFT(line,1) = '"' then parse var line '"' rubbish '"' line
    if RIGHT(line,1) = ')' then parse var line line '(' rubbish ')'
    line = strip(line)
    if RIGHT(line,1) = '>' then parse value line with rubbish '<' line '>'
return line
